﻿using System;
using System.Collections.Generic;

namespace YAWD.BL.Providers
{
    public interface IProvider
    {
        string URL { get; set; }
        string Path { get; set; }
        string FirstImage { get; set; }
        string LastDwImage { get; set; }
        string LastId { get; set; }
    
        double Current { get; set; }
        string CurrentImage { get; set; }
        IList<string> Images { get; set; }
        
        DateTime LastUpdated { get; set; }
        
        IProvider Init();
        int getAll();
        int update();
        void CancelAsync();

        event EventHandler ProgressChanged;
        event EventHandler CurrentImageChanged;
        event EventHandler ImagesChanged;

    }
}
