﻿using System;
using System.ServiceModel.Syndication;
using System.Xml;
using YAWD.Data;

namespace YAWD.BL.Services
{
    class NewsService
    {
        public static SyndicationItem CheckVersion()
        {
            XmlReader reader = null;
            try
            {
                Version lastVersion = null;
                SyndicationItem objVersion = null;

                reader = XmlReader.Create("http://yawdupdates.blogspot.com/feeds/posts/default");
                SyndicationFeed feed = SyndicationFeed.Load(reader);

                if (feed != null)
                    foreach (SyndicationItem item in feed.Items)
                    {
                        lastVersion = new Version(item.Title.Text);
                        objVersion = item;
                        break;
                    }

                Version currentVersion = Utils.Util.GetAppVersion();

                if (lastVersion != null && currentVersion != null && lastVersion.CompareTo(currentVersion) > 0)
                    return objVersion;
                else
                    return null;
            }
            catch (Exception ex)
            {
                Utils.Util.LogException(ex);
                return null;
            }
            finally
            {
                if (reader != null)
                    reader.Close();
            }
        }

        public static News GetLastNews(string id)
        {
            int latest = 0;
            if (string.IsNullOrWhiteSpace(id) == false)
                int.TryParse(id, out latest);

            return Utils.Util.GetLatestNews(latest);
        }
    }
}
